var autoLockActiveX;
var _connected = false;

/// Populate SelectDevices List with Available bluetooth devices
function DiscoverDevices()
{
    ShowProcessingStatus("Searching for Available Devices...");
    setTimeout(PopulateDevicesList, 50);    
}

function ShowProcessingStatus(message)
{
    ButtonAutoLock.style.display = "none";
    ImageProcessing.style.display = "block";
    ImageProcessing.title = message;
}

function PopulateDevicesList()
{
    try {
        var devices = autoLockActiveX.DiscoverDevices().split(";");
        SelectDevices.options.length = 0;
        for (var device = 0; device < devices.length; device++)
        {
            SelectDevices.options[device] = new Option(devices[device], devices[device]);
        }
        
        HideProcessingStatus();
    } catch (err) {
        ShowStatusMessage("Error Discovering Devices...");
    }
}

function HideProcessingStatus()
{
    ImageProcessing.style.display = "none";
    ImageProcessing.title = "";    
    ButtonAutoLock.style.display = "block";
}

function AutoLock()
{
    // Determine whether Enabling/Connecting or Disabling/Disconnecting AutoLock
    if (!_connected)
    {
        // Set Status Text    
        ShowProcessingStatus("Connecting...");
        setTimeout(Connect, 50);
        return;
    }
    Disconnect();
}

function Connect()
{   
    try {
        autoLockActiveX.DiscoverDevice(SelectDevices.options[SelectDevices.selectedIndex].value);
        autoLockActiveX.Connect();
        _connected = true;
        PingDevice();
        
        ShowConnectedStatus();
        
    } catch (err) {
        ShowStatusMessage("Error connecting...");
    }
}

function ShowConnectedStatus()
{
    HideProcessingStatus();
    AutoLockBackground.src = "images/BackgroundActive.png";
    ButtonAutoLock.value = "Disable AutoLock";
    SelectDevices.disabled = true;
    ButtonDiscover.disabled = true;
}

function ShowStatusMessage(message)
{
    HideProcessingStatus();
    ButtonAutoLock.style.display = "none";
    LabelStatusMessage.innerText = message;
    LabelStatusMessage.style.display = "block";
    setTimeout(HideStatusMessage, 5000);
}

function HideStatusMessage()
{
    ButtonAutoLock.style.display = "block";
    LabelStatusMessage.style.display = "none";
}

function PingDevice()
{
    if (_connected)
    {
        setTimeout(PingDevice, 1000)
        if (!autoLockActiveX.Ping())
        {
            Disconnect();
        }
    }
}

function Disconnect()
{
    autoLockActiveX.Disconnect();
    _connected = false;
    SelectDevices.disabled = false;
    ButtonDiscover.disabled = false;
    AutoLockBackground.src = "images/BackgroundStandby.png";
    ButtonAutoLock.value = "Enable AutoLock";
}